Skip to content
v2.274.0

CfnDataSource L1 construct ​

Creates a data source.

Example ​

ts
// The generated example for this type would exceed 500 lines,
// and has been elided for readability.
python

java

csharp
// Install: dotnet add package Amazon.CDK.Lib

go
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2

Initializer ​

ts
new CfnDataSource(scope: Construct, id: string, props: CfnDataSourceProps)
python
CfnDataSource(scope: Construct, id: str, props: CfnDataSourceProps)
java
new CfnDataSource(Construct scope, String id, CfnDataSourceProps props)
csharp
new CfnDataSource(Construct scope, string id, CfnDataSourceProps props)
go
NewCfnDataSource(Scope Construct, Id *string, Props CfnDataSourceProps)

Construct Props ​

alternateDataSourceParametersoptionalIResolvable | IResolvable | CfnDataSource.DataSourceParametersProperty[]alternate_data_source_parametersoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, DataSourceParametersProperty]]]alternateDataSourceParametersoptionalIResolvableAlternateDataSourceParametersoptionalIResolvableAlternateDataSourceParametersoptionalinterface{}#
A set of alternate data source parameters that you want to share for the credentials stored with this data source.
notes

The credentials are applied in tandem with the data source parameters when you copy a data source by using a create or update request. The API operation compares the DataSourceParameters structure that's in the request with the structures in the AlternateDataSourceParameters allow list. If the structures are an exact match, the request is allowed to use the credentials from this existing data source. If the AlternateDataSourceParameters list is null, the Credentials originally used with this DataSourceParameters are automatically allowed.

awsAccountIdoptionalstringaws_account_idoptionalstrawsAccountIdoptionalStringAwsAccountIdoptionalstringAwsAccountIdoptional*string#
The AWS account ID.
credentialsoptionalIResolvable | CfnDataSource.DataSourceCredentialsPropertycredentialsoptionaltyping.Union[IResolvable, DataSourceCredentialsProperty]credentialsoptionalIResolvableCredentialsoptionalIResolvableCredentialsoptionalinterface{}#
The credentials Amazon Quick Sight that uses to connect to your underlying source.

Currently, only credentials based on user name and password are supported.

dataSourceIdoptionalstringdata_source_idoptionalstrdataSourceIdoptionalStringDataSourceIdoptionalstringDataSourceIdoptional*string#
An ID for the data source.

This ID is unique per AWS Region for each AWS account.

dataSourceParametersoptionalIResolvable | CfnDataSource.DataSourceParametersPropertydata_source_parametersoptionaltyping.Union[IResolvable, DataSourceParametersProperty]dataSourceParametersoptionalIResolvableDataSourceParametersoptionalIResolvableDataSourceParametersoptionalinterface{}#
The parameters that Amazon Quick Sight uses to connect to your underlying source.
errorInfooptionalIResolvable | CfnDataSource.DataSourceErrorInfoPropertyerror_infooptionaltyping.Union[IResolvable, DataSourceErrorInfoProperty]errorInfooptionalIResolvableErrorInfooptionalIResolvableErrorInfooptionalinterface{}#
Error information from the last update or the creation of the data source.
folderArnsoptionalstring[]folder_arnsoptionaltyping.List[str]folderArnsoptionalList<String>FolderArnsoptionalstring[]FolderArnsoptional*[]*string#
namestringnamestrnameStringNamestringName*stringrequired#
A display name for the data source.
permissionsoptionalIResolvable | IResolvable | CfnDataSource.ResourcePermissionProperty[]permissionsoptionaltyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ResourcePermissionProperty]]]permissionsoptionalIResolvablePermissionsoptionalIResolvablePermissionsoptionalinterface{}#
A list of resource permissions on the data source.
sslPropertiesoptionalIResolvable | CfnDataSource.SslPropertiesPropertyssl_propertiesoptionaltyping.Union[IResolvable, SslPropertiesProperty]sslPropertiesoptionalIResolvableSslPropertiesoptionalIResolvableSslPropertiesoptionalinterface{}#
Secure Socket Layer (SSL) properties that apply when Amazon Quick Sight connects to your underlying source.
tagsoptionalCfnTag[]tagsoptionaltyping.List[CfnTag]tagsoptionalList<CfnTag>TagsoptionalCfnTag[]Tagsoptional*[]CfnTag#
Contains a map of the key-value pairs for the resource tag or tags assigned to the data source.
typestringtypestrtypeStringTypestringType*stringrequired#
The type of the data source. To return a list of all data sources, use `ListDataSources` .

Use AMAZON_ELASTICSEARCH for Amazon OpenSearch Service.

vpcConnectionPropertiesoptionalIResolvable | CfnDataSource.VpcConnectionPropertiesPropertyvpc_connection_propertiesoptionaltyping.Union[IResolvable, VpcConnectionPropertiesProperty]vpcConnectionPropertiesoptionalIResolvableVpcConnectionPropertiesoptionalIResolvableVpcConnectionPropertiesoptionalinterface{}#
Use this parameter only when you want Amazon Quick Sight to use a VPC connection when connecting to your underlying source.

Properties ​

alternateDataSourceParametersmay be undefinedIResolvable | IResolvable | CfnDataSource.DataSourceParametersProperty[]alternate_data_source_parametersmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, DataSourceParametersProperty]]]alternateDataSourceParametersmay be undefinedIResolvableAlternateDataSourceParametersmay be undefinedIResolvableAlternateDataSourceParametersmay be undefinedinterface{}#
A set of alternate data source parameters that you want to share for the credentials stored with this data source.
attrArnstringattr_arnstrattrArnStringAttrArnstringAttrArn*string#
The Amazon Resource Name (ARN) of the dataset.
attrCreatedTimestringattr_created_timestrattrCreatedTimeStringAttrCreatedTimestringAttrCreatedTime*string#
The time that this data source was created.
attrLastUpdatedTimestringattr_last_updated_timestrattrLastUpdatedTimeStringAttrLastUpdatedTimestringAttrLastUpdatedTime*string#
The last time that this data source was updated.
attrStatusstringattr_statusstrattrStatusStringAttrStatusstringAttrStatus*string#
The HTTP status of the request.
awsAccountIdmay be undefinedstringaws_account_idmay be undefinedstrawsAccountIdmay be undefinedStringAwsAccountIdmay be undefinedstringAwsAccountIdmay be undefined*string#
The AWS account ID.
CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringstatic#
The CloudFormation resource type name for this resource class.
Options for this resource, such as condition, update policy etc.
cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*string#
AWS resource type.
creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*string#
credentialsmay be undefinedIResolvable | CfnDataSource.DataSourceCredentialsPropertycredentialsmay be undefinedtyping.Union[IResolvable, DataSourceCredentialsProperty]credentialsmay be undefinedIResolvableCredentialsmay be undefinedIResolvableCredentialsmay be undefinedinterface{}#
The credentials Amazon Quick Sight that uses to connect to your underlying source.
dataSourceIdmay be undefinedstringdata_source_idmay be undefinedstrdataSourceIdmay be undefinedStringDataSourceIdmay be undefinedstringDataSourceIdmay be undefined*string#
An ID for the data source.
dataSourceParametersmay be undefinedIResolvable | CfnDataSource.DataSourceParametersPropertydata_source_parametersmay be undefinedtyping.Union[IResolvable, DataSourceParametersProperty]dataSourceParametersmay be undefinedIResolvableDataSourceParametersmay be undefinedIResolvableDataSourceParametersmay be undefinedinterface{}#
The parameters that Amazon Quick Sight uses to connect to your underlying source.
dataSourceRefDataSourceReferencedata_source_refDataSourceReferencedataSourceRefDataSourceReferenceDataSourceRefDataSourceReferenceDataSourceRefDataSourceReference#
A reference to a DataSource resource.
errorInfomay be undefinedIResolvable | CfnDataSource.DataSourceErrorInfoPropertyerror_infomay be undefinedtyping.Union[IResolvable, DataSourceErrorInfoProperty]errorInfomay be undefinedIResolvableErrorInfomay be undefinedIResolvableErrorInfomay be undefinedinterface{}#
Error information from the last update or the creation of the data source.
folderArnsmay be undefinedstring[]folder_arnsmay be undefinedtyping.List[str]folderArnsmay be undefinedList<String>FolderArnsmay be undefinedstring[]FolderArnsmay be undefined*[]*string#
logicalIdstringlogical_idstrlogicalIdStringLogicalIdstringLogicalId*string#
The logical ID for this CloudFormation stack element.

The logical ID of the element is calculated from the path of the resource node in the construct tree.

To override this value, use overrideLogicalId(newLogicalId).

namestringnamestrnameStringNamestringName*string#
A display name for the data source.
nodeNodenodeNodenodeNodeNodeNodeNodeNode#
The tree node.
permissionsmay be undefinedIResolvable | IResolvable | CfnDataSource.ResourcePermissionProperty[]permissionsmay be undefinedtyping.Union[IResolvable, typing.List[typing.Union[IResolvable, ResourcePermissionProperty]]]permissionsmay be undefinedIResolvablePermissionsmay be undefinedIResolvablePermissionsmay be undefinedinterface{}#
A list of resource permissions on the data source.
refstringrefstrrefStringRefstringRef*string#
Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).

sslPropertiesmay be undefinedIResolvable | CfnDataSource.SslPropertiesPropertyssl_propertiesmay be undefinedtyping.Union[IResolvable, SslPropertiesProperty]sslPropertiesmay be undefinedIResolvableSslPropertiesmay be undefinedIResolvableSslPropertiesmay be undefinedinterface{}#
Secure Socket Layer (SSL) properties that apply when Amazon Quick Sight connects to your underlying source.
stackStackstackStackstackStackStackStackStackStack#
The stack in which this element is defined.

CfnElements must be defined within a stack scope (directly or indirectly).

Tag Manager which manages the tags for this resource.
tagsRawmay be undefinedCfnTag[]tags_rawmay be undefinedtyping.List[CfnTag]tagsRawmay be undefinedList<CfnTag>TagsRawmay be undefinedCfnTag[]TagsRawmay be undefined*[]CfnTag#
Contains a map of the key-value pairs for the resource tag or tags assigned to the data source.
typestringtypestrtypeStringTypestringType*string#
The type of the data source.

To return a list of all data sources, use ListDataSources .

vpcConnectionPropertiesmay be undefinedIResolvable | CfnDataSource.VpcConnectionPropertiesPropertyvpc_connection_propertiesmay be undefinedtyping.Union[IResolvable, VpcConnectionPropertiesProperty]vpcConnectionPropertiesmay be undefinedIResolvableVpcConnectionPropertiesmay be undefinedIResolvableVpcConnectionPropertiesmay be undefinedinterface{}#
Use this parameter only when you want Amazon Quick Sight to use a VPC connection when connecting to your underlying source.

Methods ​

addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#
Syntactic sugar for `addOverride(path, undefined)`.
1 parameter

Parameters

  • pathpathpathpathPath — The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#
Use `addResourceDependency` instead.

This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.

addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#
Use `addResourceDependency` instead.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.

addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#
Add a value to the CloudFormation Resource Metadata.
addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#
Adds an override to the synthesized CloudFormation resource.
notes · 2 parameters

To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).

If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.

To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.

For example,

typescript
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');

would add the overrides

json
"Properties": {
  "GlobalSecondaryIndexes": [
    {
      "Projection": {
        "NonKeyAttributes": [ "myattribute" ]
        ...
      }
      ...
    },
    {
      "ProjectionType": "INCLUDE"
      ...
    },
  ]
  ...
}

The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.

Parameters

  • pathpathpathpathPath — - The path of the property, you can use dot notation to override values in complex types.
  • valuevaluevaluevalueValue — - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#
Adds an override that deletes the value of a property from the resource definition.
1 parameter

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#
Adds an override to a resource property.

Syntactic sugar for addOverride("Properties.<...>", value).

2 parameters

Parameters

  • propertyPathproperty_pathpropertyPathpropertyPathPropertyPath — The path of the property.
  • valuevaluevaluevalueValue — The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#
Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.
notes

This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.

This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.

applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#
Sets the cross-stack reference strength for this resource.

When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.

1 parameter

Parameters

  • strengthstrengthstrengthstrengthStrength — - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#
Sets the deletion policy of the resource based on the removal policy specified.
notes

The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.

The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:

arnForDataSource(resource: IDataSourceRef): string@staticmethod def arn_for_data_source(resource: IDataSourceRef) -> strpublic static String arnForDataSource(IDataSourceRef resource)public static string ArnForDataSource(IDataSourceRef resource)func ArnForDataSource(Resource IDataSourceRef) *stringstatic#
cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#
getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#
Returns a token for an runtime attribute of this resource.

Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.

1 parameter

Parameters

  • attributeNameattribute_nameattributeNameattributeNameAttributeName — The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#
Retrieve a value value from the CloudFormation Resource Metadata.
inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#
Examines the CloudFormation resource and discloses attributes.
1 parameter

Parameters

  • inspectorinspectorinspectorinspectorInspector — tree inspector to collect and process attributes.
isCfnDataSource(x: any): boolean@staticmethod def is_cfn_data_source(x: Any) -> boolpublic static Boolean isCfnDataSource(Object x)public static bool IsCfnDataSource(object x)func IsCfnDataSource(X interface{}) *boolstatic#
Checks whether the given object is a CfnDataSource.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#
Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.

returns

Returns: The construct as a stack element or undefined if it is not a stack element.

isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#
Check whether the given object is a CfnResource.
isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#
Checks if `x` is a construct.
notes · 1 parameter · returns

Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.

Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

Parameters

  • xxxxX — Any object.

Returns: true if x is an object created from a class which extends Construct.

obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#
Retrieves an array of resources and stacks this resource depends on.

For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.

overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#
Overrides the auto-generated logical ID with a specific ID.
1 parameter

Parameters

  • newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId — The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#
Use `removeResourceDependency` instead

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#
Indicates that this resource no longer depends on another resource.

This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.

replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#
Replaces one dependency with another.
2 parameters

Parameters

  • targettargettargettargetTarget — The dependency to replace.
  • newTargetnew_targetnewTargetnewTargetNewTarget — The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#
Returns a string representation of this construct.
returns

Returns: a string representation of this resource

with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#
Applies one or more mixins to this construct.

Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.